import java.awt.*;

        // Layout a number of buttons to illustrate positioning
        // and row and column spanning with a GridBagLayout.
class GridBagLayoutFrame extends Frame {
    public GridBagLayoutFrame(){
        final int width = 150, height = 150;
        setSize(width,height);
        setBackground(Color.white);
        // Use a slightly larger than normal font.
        setFont(new Font("SansSerif",Font.BOLD,20));

        // Create the layout manager.
        GridBagLayout layout = new GridBagLayout();
        setLayout(layout);
        setupComponents();
    }

        // Setup the required set of components in this container.
    protected void setupComponents(){
        // Create the constraints. Reuse this object with each button.
        GridBagConstraints constraints = new GridBagConstraints();

        // Create each button, set up its constraints and
        // add it to the frame.
        final int singleCell = 1, wider = 2, higher = 2;
        initBasicConstraints(constraints,0,0,singleCell,higher);
        addButton("1",constraints);

        initBasicConstraints(constraints,1,0,singleCell,singleCell);
        addButton("2",constraints);

        initBasicConstraints(constraints,1,1,singleCell,singleCell);
        addButton("3",constraints);

        initBasicConstraints(constraints,2,0,wider,singleCell);
        addButton("4",constraints);

        initBasicConstraints(constraints,2,1,singleCell,singleCell);
        addButton("5",constraints);

        initBasicConstraints(constraints,3,1,singleCell,singleCell);
        addButton("6",constraints);
    }

        // Initialise the x,y width,height values for the constraints.
    protected void initBasicConstraints(GridBagConstraints constraints,
                                int x, int y, int width, int height){
        constraints.gridx = x;
        constraints.gridy = y;
        constraints.gridwidth = width;
        constraints.gridheight = height;
        constraints.weightx = 1.0;
        constraints.weighty = 1.0;
        constraints.fill = GridBagConstraints.BOTH;
    }

        // Add a button to the Frame with the given label and constraints.
    protected void addButton(String label, GridBagConstraints constraints){
        Button b = new Button(label);
        add(b,constraints);
    }
}
