        // A simple Stop Watch interface

interface StopWatch {
    // The states the watch may be in.
    static final int RESET = 0;
    static final int RUNNING = 1;
    static final int SUSPENDED = 2;
    static final int STOPPED = 3;

    // Enquiry function for the current state, returns
    // one of RESET, RUNNING, SUSPENDED and STOPPED.
    public int getState();

    public void reset();
    public void start();
    public void stop();
    public void suspend();
    public void resume();

    public long getElapsedTime();
}
