    /* Read a file of word and definition pairs and then allow
     * interactive querying of the glossary.
     * The file should contain each word on a separate line, followed
     * by its definition on the next line.
     * The end of the file should be marked by the word: end
     */
class GlossaryMain {
    public static void main(String[] args){
        GlossaryManager gloss;
        // Check for the name of a glossary file.
        if(args.length == 1){
            // Set up the glossary from the file.
            gloss = new GlossaryManager(args[0]);
        }
        else{
            // Use the default (GlossaryManager.defaultFile).
            gloss = new GlossaryManager();
        }
        // Allow the user to look up words in the glossary.
        gloss.interact();
    }
}
