    // Attempts to create a circle with a non-positive radius
    // will fail.
class Circle {
    public Circle(double r) throws RuntimeException {
        if(r <= 0){
            throw new RuntimeException("The radius must be positive: "+r);
        }
        radius = r;
    }

    public double circumference(){
        return 2*Math.PI*getRadius();
    }

    public double area(){
        final double r = getRadius();
        return Math.PI*r*r;
    }

    public double getRadius(){
        return radius;
    }

    private final double radius;
}
