import java.io.*;

        // Illustrate the way to read a file in a single read.
class Copy {
    public static void main(String[] args) throws IOException {
        if(args.length == 1){
            FileReader reader = null;
            FileWriter writer = null;
            try{
                final String outputFile = "output.txt";
                // Use a File in order to find out the file's length.
                final File f = new File(args[0]);
                // Open the input and output files.
                reader = new FileReader(f);
                writer = new FileWriter(outputFile);
                // Attempt to read the whole file in a single read.
                final int fileSize = (int) f.length();
                // Allocate sufficient space.
                char[] buffer = new char [fileSize];

                if(fileSize != f.length()){
                    throw new IOException("File size mismatch.");
                }
                else if(reader.read(buffer,0,fileSize) != fileSize){
                    throw new IOException("Read failure.");
                }
                else{
                    writer.write(buffer);
                    writer.flush();
                    System.out.println(outputFile+" written.");
                }
            }
            finally{
                if(reader != null){
                    reader.close();
                }
                if(writer != null){
                    writer.close();
                }
            }
        }
    }
}
