        // Refill all tanks in the gas station.
class Refill extends Event {
    // Time between refills.
    public static final long refillPeriod = 8L*60*60;

    public Refill(long eventTime,GasStation f){
        super(eventTime);
        station = f;
    }

    public void perform(Scheduler scheduler){
        GasStation station = getStation();
        // Schedule the next refill.
        long now = scheduler.getTime();
        scheduler.schedule(new Refill(nextRefillTime(now),station));

        station.refill();
    }

    public String toString(){
        return getWhen()+" Refill";
    }

        // Calculate when the next refill should occur.
    protected long nextRefillTime(long now){
        // Simulate a Poisson distribution of arrivals.
        return now + refillPeriod;
    }

    protected GasStation getStation(){
        return station;
    }

    private final GasStation station;
}
