import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

        // Display two JToggleButtons.
class SwingToggleFrame extends JFrame {
    public SwingToggleFrame() {
        final int width = 300, height = 120;
        setSize(width,height);
        Container contents = getContentPane();

        // Create two JToggleButtons. One listens for
        // changes, the other is passive.
        final JToggleButton passiveButton = new JToggleButton("Passive");
        // Initially the second button is selected.
        final JToggleButton activeButton = new JToggleButton("On");
        activeButton.setSelected(true);
        // Make the text on the button respond to its state.
        activeButton.addItemListener(new ItemListener(){
            public void itemStateChanged(ItemEvent e){
                int change = e.getStateChange();
                if(change == ItemEvent.SELECTED){
                    activeButton.setText("On");
                }
                else{
                    activeButton.setText("Off");
                }
            }
        });

        // Add the buttons to a central panel.
        final JPanel togglePanel = new JPanel();
        togglePanel.add(passiveButton);
        togglePanel.add(activeButton);
        contents.add(togglePanel,"Center");

        contents.add(new QuitJPanel(),"South");
    }
}
